//+------------------------------------------------------------------+
//|                                  !Ajax_Daily_HiLo_SideCandle.mq4 |
//|                                                                  |
//| Coded by San4x, 2011                                          |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LightGreen
#property indicator_color2  Orange
#property indicator_color3  LightGreen
#property indicator_color4  Orange
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2

extern int    CandleShift    = 2;

double DayHigh[];
double DayLow[];
double DayOpen[];
double DayClose[];

string indNames = "YestData";
int    DataBar, DataPeriod;
double new_high, new_low, curr_high, curr_low, current_tf;
double OpDAILY, HiDAILY, LoDAILY, ClDAILY, change;

//+------------------------------------------------------------------+
//+                                                                  +
//+------------------------------------------------------------------+  
int init() {
   SetIndexBuffer(0, DayHigh);
   SetIndexBuffer(1, DayLow);
   SetIndexBuffer(2, DayClose);
   SetIndexBuffer(3, DayOpen);
   for (int i=0;i<4;i++){
         SetIndexStyle(i,DRAW_HISTOGRAM);
         SetIndexShift(i,CandleShift);
         SetIndexLabel(i,"Yest data");
   }            
   switch(Period()){
      case PERIOD_MN1:
      case PERIOD_W1:  DataPeriod = PERIOD_MN1; break;
      case PERIOD_D1:  DataPeriod = PERIOD_W1;  break;
      default:         DataPeriod = PERIOD_D1;
   } 
   return (0);
}
//+------------------------------------------------------------------+
//+                                                                  +
//+------------------------------------------------------------------+  
int deinit() {
   for (int k=-1; k<(30); k++){
      ObjectDelete(indNames+k);
   }
   return (0);
}

//+------------------------------------------------------------------+
//+                                                                  +
//+------------------------------------------------------------------+  
int start() {
   fDailyData_v01();
   return (0);
}

//+------------------------------------------------------------------+
//+                                                                  +
//+------------------------------------------------------------------+  
void fDailyData_v01(){
   int    digits   = MarketInfo(Symbol(),MODE_DIGITS);
   double modifier = 1;
   if (digits==3 || digits==5) modifier = 10.0;
   int    limit,i;

   DataBar         = iBarShift(NULL,1440,Time[0]);
   
   if(DayOfWeek()==1){
      OpDAILY  = iOpen (NULL,DataPeriod,2);
      HiDAILY  = iHigh (NULL,DataPeriod,2);
      LoDAILY  = iLow  (NULL,DataPeriod,2); 
      ClDAILY  = iClose(NULL,DataPeriod,2);

      change   = (ClDAILY-iOpen(NULL,DataPeriod,2))/(Point*modifier);
//      setBarIndicator(change,HiDAILY,LoDAILY,iOpen(NULL,DataPeriod,2),ClDAILY);
      setBarIndicator(change,HiDAILY,LoDAILY,OpDAILY,ClDAILY);   
   
   }else if(DayOfWeek()==2){
//      OpDAILY  = MathMax(iOpen (NULL,DataPeriod,1),iOpen (NULL,DataPeriod,2));
      OpDAILY  = iOpen (NULL,DataPeriod,1);
      HiDAILY  = MathMax(iHigh (NULL,DataPeriod,1),iHigh (NULL,DataPeriod,2));
      LoDAILY  = MathMin(iLow  (NULL,DataPeriod,1),iLow  (NULL,DataPeriod,2)); 
//      ClDAILY  = MathMin(iClose(NULL,DataPeriod,1),iClose(NULL,DataPeriod,2));
      ClDAILY  = iClose(NULL,DataPeriod,1);

      change   = (ClDAILY-iOpen(NULL,DataPeriod,1))/(Point*modifier);
//      setBarIndicator(change,HiDAILY,LoDAILY,iOpen(NULL,DataPeriod,1),ClDAILY);   
      setBarIndicator(change,HiDAILY,LoDAILY,OpDAILY,ClDAILY);

   }else{
      OpDAILY  = iOpen (NULL,DataPeriod,1);
      HiDAILY  = iHigh (NULL,DataPeriod,1);
      LoDAILY  = iLow  (NULL,DataPeriod,1); 
      ClDAILY  = iClose(NULL,DataPeriod,1);

      change   = (ClDAILY-iOpen(NULL,DataPeriod,1))/(Point*modifier);
//      setBarIndicator(change,HiDAILY,LoDAILY,iOpen(NULL,DataPeriod,1),ClDAILY);
      setBarIndicator(change,HiDAILY,LoDAILY,OpDAILY,ClDAILY);
   }   
   for(i=0,limit=Bars-1;i<4;i++) SetIndexDrawBegin(i,limit); 
}

//+------------------------------------------------------------------+
//+                                                                  +
//+------------------------------------------------------------------+  
void setBarIndicator(double change, double hi,double low, double open, double close){
   string name  = indNames+"-1";
   int    shift = 0;
   
   if (change>0) { DayHigh[shift]  = hi;  DayLow[shift] = low; }            
   else          { DayHigh[shift]  = low; DayLow[shift] = hi;  }            
                   DayOpen[shift]  = open;
                   DayClose[shift] = close;       
}